module CanonMod10

open FStar.Algebra.CommMonoid.Equiv
open FStar.Tactics.CanonCommMonoidSimple.Equiv2 // slightly modified
open FStar.Math.Lemmas
open FStar.Tactics
open FStar.Mul

let cong10 (x y : int) : Type0 = x%10 == y%10

let eq_mod : equiv int =
  EQ cong10
     (fun _ -> ())
     (fun _ _ -> ())
     (fun _ _ _ -> ())

(* Actually a ring, but we can just forget that. *)
let int_mod : cm int eq_mod =
  CM 0
     (+)
     (fun _ -> ())
     (fun _ _ _ -> ())
     (fun _ _ -> ())
     (fun a b c d -> ())

let canon10 () : Tac unit =
    dump "before";
    canon_monoid (`eq_mod) (`int_mod);
    norm [delta_fully [`%(CM?.mult); `%int_mod]];
    norm [iota];
    dump "after"
    
let test0 (a : int) =
  let (==) = (eq_mod).eq in
  assert (a == a) by canon10 ()
  
let test1 (a b c : int) =
  let (==) = (eq_mod).eq in
  assert (a + (b + c) == (c + a) + b) by canon10 ()

let test2 (a b c : int) =
  let (==) = (eq_mod).eq in
  assert (a + (a + 0 + (a + (a + a))) == (((0 + a + a) + a) + a) + a) by begin
    canon10 ();
    //compute();
    //trefl();
    ()
  end
  
let test3 (a b c : int) =
  let (==) = (eq_mod).eq in
  assert (a + 10 == 0 + 1*a) by begin
    canon10 ();
    ()
  end

let test4 (a b c : int) =
  let (==) = (eq_mod).eq in
  assert (20 + 0 + 11*b + a + c + a == b + 2*a + 0 + c) by canon10 ()
